find_path(MOOS_CORE_INCLUDE_DIR MOOSLIB/MOOSLib.h 
  HINTS ~/moos-ivp ~/
  PATH_SUFFIXES MOOS/Core)

find_path(MOOS_ESSENTIAL_INCLUDE_DIR MOOSUtilityLib/MOOSGeodesy.h
  HINTS ~/moos-ivp ~/
  PATH_SUFFIXES MOOS/Essentials)

#message("MOOS Include DIR: ${MOOS_INCLUDE_DIR}")

find_library(MOOS_LIBRARY NAMES MOOS
  DOC "The MOOS library"
  HINTS ~/moos-ivp ~/
  PATH_SUFFIXES MOOS/MOOSBin)

#message("MOOS LIBRARY: ${MOOS_LIBRARY}"

find_library(MOOS_GEN_LIBRARY NAMES MOOSGen
  DOC "The MOOS general library"
  HINTS ~/moos-ivp ~/
  PATH_SUFFIXES MOOS/MOOSBin)

#message("MOOS GEN LIBRARY: ${MOOS_GEN_LIBRARY}")

find_library(MOOS_UTILITY_LIBRARY NAMES MOOSUtility
  DOC "The MOOS utility library"
  HINTS ~/moos-ivp ~/
  PATH_SUFFIXES MOOS/MOOSBin)

#message("MOOS UTILITY LIBRARY: ${MOOS_UTILITY_LIBRARY}")

mark_as_advanced(MOOS_CORE_INCLUDE_DIR MOOS_ESSENTIAL_INCLUDE_DIR
  MOOS_LIBRARY MOOS_GEN_LIBRARY MOOS_UTILITY_LIBRARY) 

include(FindPackageHandleStandardArgs)
FIND_PACKAGE_HANDLE_STANDARD_ARGS(MOOS DEFAULT_MSG
  MOOS_CORE_INCLUDE_DIR MOOS_ESSENTIAL_INCLUDE_DIR MOOS_GEN_LIBRARY MOOS_UTILITY_LIBRARY)

if(MOOS_FOUND)
  set(MOOS_INCLUDE_DIRS ${MOOS_CORE_INCLUDE_DIR} ${MOOS_ESSENTIAL_INCLUDE_DIR})
  set(MOOS_LIBRARIES ${MOOS_LIBRARY} ${MOOS_GEN_LIBRARY} ${MOOS_UTILITY_LIBRARY})
endif()

